/*
Based on code by Fernando Dashiiki http://fernando.dubtribe.com
in turn based on code provided as 'RSS Sample' from developer.apple.com
*/

//the url of the feed
var feedurl = "http://123macmini.com/widget/widget.xml";

//how long to wait between updates in MINUTES
var updateInterval = 60;

function load (){
	if (!window.widget){
		show ();
	}
 }

if(window.widget){
    widget.onshow = show;
    widget.onhide = hide;
}


/**
*   The flipping functions just change the front and back divs to either display as block or inline,
*   and sets the background image for the <body> to either Default.png or Back.png
*/


/* flips to the front*/
function fliptofront(){
    if(window.widget){
        widget.prepareForTransition("ToFront");
    }
    document.getElementById('front').style.display='block';
    document.getElementById('back').style.display='none';
    document.getElementById('thebody').className = 'bodyfront';
    if(window.widget){
        setTimeout ('widget.performTransition();', 0);
    }
}
/*flips to the back*/
function fliptoback(){
    if(window.widget){
        widget.prepareForTransition("ToBack");
    }
    document.getElementById('front').style.display='none';
    document.getElementById('back').style.display='block';
    document.getElementById('thebody').className = 'bodyback';
    if(window.widget){
        setTimeout ('widget.performTransition();', 0);
    }
}

/*animating the info button*/

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
        var starttime = (new Date).getTime() - 13;
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}
function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
        var starttime = (new Date).getTime() - 13;
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}
function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
    T = limit_3(time-animation.starttime, 0, animation.duration);
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
    animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function enterflip(event)
{
    document.getElementById('fliprollie').style.display = 'block';
}
function exitflip(event)
{
    document.getElementById('fliprollie').style.display = 'none';
}


/*feed reading*/

var xml_request = null;
var timer = null;


//stops the refresh timer

var widgetIsVisible = false;
function hide(){
    if(timer != null){
        clearInterval(timer);
        timer = null;
    }
}


function getData(){
    //alert("got live data");
	xml_request = new XMLHttpRequest();
	xml_request.onload = function(e) {xml_loaded(e, xml_request);}
	xml_request.overrideMimeType("text/xml");
	xml_request.open("GET", feedurl);
	xml_request.setRequestHeader("Cache-Control", "no-cache");
	xml_request.send(null);

}

var lastUpdated = 0;

function show (){
    var now = (new Date).getTime();
    //alert("checked time" + ((now-lastUpdated)/(1000*60)));
    if(now-lastUpdated > updateInterval * 1000*60){
        getData();
        lastUpdated = now;
    }
    if(timer==null){
        timer = setInterval("show();",1000*60 );
    }
}

if (window.widget){
	widget.onshow = show;
}


//-----------------------------------------------------------------------------
// findChild - scan the children of a given DOM element for a node matching
// nodeName; much more efficient than the standard DOM methods
// (getElementsByTagName, etc) if you know what you're looking for
//-----------------------------------------------------------------------------

function findChild (element, nodeName)
{
	var child;
	for (child = element.firstChild; child != null; child = child.nextSibling){
		if (child.nodeName == nodeName){
			return child;
		}
	}
	return null;
}


function xml_loaded (e, request) {
   
	xml_request = null;
	if (request.responseXML){
		// Get the top level <rss> element 
		var rss = findChild(request.responseXML, 'rss');		
		if (!rss) {return;}
		
		// Get single subordinate channel element
		var channel = findChild( rss, 'channel');
		if (!channel) {return;}
		
		var results = new Array;
		
		// Get all item elements subordinate to the channel element
		// For each element, get title, link and publication date. 
		// Note that all elements of an item are optional. 
	
		for( var item = channel.firstChild; item != null; item = item.nextSibling){
			if( item.nodeName == 'item' ){
				var title = findChild (item, 'title');
				// we have to have the title to include the item in the list 
				if( title != null ){
					var link = findChild (item, 'link');
					var pubDate = findChild (item, 'pubDate');
					results[results.length] = {title:title.firstChild.data, 
						link:(link != null ? link.firstChild.data : null), 
						date:new Date(Date.parse(pubDate.firstChild.data))};
				}
			}
		}
		
		// sort by date
		results.sort (compFunc);
		 
		nItems = results.length;
        
		for (var i = 0; i < nItems && i < 6; i++){
			var item = results[i];
			html = "<a href=\"javascript:widget.openURL('"+item.link+"')\">";
			html += item.title;
			html += "</a>";
			document.getElementById('item'+(i+1)).innerHTML = html;
		}
	}
}

//-----------------------------------------------------------------------------
// sortFunc - compare function used for sorting dates
//-----------------------------------------------------------------------------

function compFunc (a, b){
	if (a.date < b.date)
		return 1;
	else if (a.date > b.date)
		return -1;
	else
		return 0;
}
